## rspamd 3.6

=== CMakeLists.txt ===
#
# Rspamd - rapid antispam system
#
# Cmake configuration file
#

############################# INITIAL SECTION #############################################
CMAKE_MINIMUM_REQUIRED(VERSION 3.12 FATAL_ERROR)

SET(RSPAMD_VERSION_MAJOR 3)
SET(RSPAMD_VERSION_MINOR 6)

# Keep two digits all the time
SET(RSPAMD_VERSION_MAJOR_NUM ${RSPAMD_VERSION_MAJOR}0)
SET(RSPAMD_VERSION_MINOR_NUM ${RSPAMD_VERSION_MINOR}0)

IF (GIT_ID)
    SET(GIT_VERSION 1)
    SET(RSPAMD_ID "${GIT_ID}")
ENDIF ()

SET(RSPAMD_VERSION "${RSPAMD_VERSION_MAJOR}.${RSPAMD_VERSION_MINOR}")

PROJECT(rspamd VERSION "${RSPAMD_VERSION}" LANGUAGES C CXX ASM)

CMAKE_POLICY(SET CMP0075 NEW)

# This is supported merely with cmake 3.1
SET(CMAKE_C_STANDARD 11)
SET(CMAKE_CXX_STANDARD 20)
SET(CMAKE_C_STANDARD_REQUIRED ON)
SET(CMAKE_CXX_STANDARD_REQUIRED ON)
LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/")

SET(RSPAMD_MASTER_SITE_URL "https://rspamd.com")

IF (NOT RSPAMD_USER)
    SET(RSPAMD_USER "nobody")
    SET(RSPAMD_GROUP "nobody")
ENDIF (NOT RSPAMD_USER)

# Default for SysV Init
SET(RSPAMD_WORKER_NORMAL "*:11333")
SET(RSPAMD_WORKER_CONTROLLER "*:11334")

############################# OPTIONS SECTION #############################################
OPTION(ENABLE_LUAJIT "Link with libluajit [default: ON]" ON)
OPTION(ENABLE_URL_INCLUDE "Enable urls in ucl includes (requires libcurl or libfetch) [default: OFF]" OFF)
OPTION(NO_SHARED "Build internal libs static [default: ON]" ON)
OPTION(INSTALL_WEBUI "Install web interface [default: ON]" ON)
OPTION(WANT_SYSTEMD_UNITS "Install systemd unit files on Linux [default: OFF]" OFF)
OPTION(ENABLE_SNOWBALL "Enable snowball stemmer [default: ON]" ON)
OPTION(ENABLE_CLANG_PLUGIN "Enable clang static analysing plugin [default: OFF]" OFF)
OPTION(ENABLE_PCRE2 "Enable pcre2 instead of pcre  [default: ON]" ON)
OPTION(ENABLE_JEMALLOC "Build rspamd with jemalloc allocator  [default: OFF]" OFF)
OPTION(ENABLE_UTILS "Build rspamd internal utils [default: OFF]" OFF)
OPTION(ENABLE_LIBUNWIND "Use libunwind to print crash traces [default: OFF]" OFF)
OPTION(ENABLE_LUA_TRACE "Trace all Lua C API invocations [default: OFF]" OFF)
OPTION(ENABLE_LUA_REPL "Enables Lua repl (requires C++11 compiler) [default: ON]" ON)
OPTION(ENABLE_FASTTEXT "Link with FastText library [default: OFF]" OFF)
OPTION(SYSTEM_ZSTD "Use system zstd instead of bundled one [default: OFF]" OFF)
OPTION(SYSTEM_FMT "Use system fmt instead of bundled one [default: OFF]" OFF)
OPTION(SYSTEM_DOCTEST "Use system doctest instead of bundled one [default: OFF]" OFF)
OPTION(SYSTEM_XXHASH "Use system xxhash instead of bundled one [default: OFF]" OFF)

############################# INCLUDE SECTION #############################################

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckCSourceCompiles)
INCLUDE(CheckCSourceRuns)
INCLUDE(CheckLibraryExists)
INCLUDE(CheckCCompilerFlag)
INCLUDE(CMakeParseArguments)
INCLUDE(FindArch)
INCLUDE(AsmOp)
INCLUDE(FindRagel)
INCLUDE(ProcessPackage)

IF (NOT RAGEL_FOUND)
    MESSAGE(FATAL_ERROR "Ragel is required to build rspamd")
ENDIF ()

FIND_PACKAGE(PkgConfig REQUIRED)
FIND_PACKAGE(Perl REQUIRED)

option(SANITIZE "Enable sanitizer: address, memory, undefined, leak (comma separated list)" "")
INCLUDE(Toolset)
INCLUDE(Sanitizer)

INCLUDE(ArchDep)
INCLUDE(Paths)

IF (ENABLE_PCRE2 MATCHES "ON")
    SET(WITH_PCRE2 1)
    # For utf8 API
    LIST(APPEND CMAKE_REQUIRED_DEFINITIONS "-DPCRE2_CODE_UNIT_WIDTH=8")
ENDIF ()
############################# CONFIG SECTION #############################################
# Initial set

# Prefer local include dirs to system ones
INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/"
        "${CMAKE_SOURCE_DIR}/src"
        "${CMAKE_SOURCE_DIR}/src/libutil"
        "${CMAKE_SOURCE_DIR}/src/libserver"
        "${CMAKE_SOURCE_DIR}/src/libmime"
        "${CMAKE_SOURCE_DIR}/src/libstat"
        "${CMAKE_SOURCE_DIR}/src/libcryptobox"
        "${CMAKE_SOURCE_DIR}/contrib/libucl"
        "${CMAKE_SOURCE_DIR}/contrib/replxx/include"
        "${CMAKE_SOURCE_DIR}/contrib/uthash"
        "${CMAKE_SOURCE_DIR}/contrib/http-parser"
        "${CMAKE_SOURCE_DIR}/contrib/fpconv"
        "${CMAKE_SOURCE_DIR}/contrib/libottery"
        "${CMAKE_SOURCE_DIR}/contrib/cdb"
        "${CMAKE_SOURCE_DIR}/contrib/snowball/include"
        "${CMAKE_SOURCE_DIR}/contrib/librdns"
        "${CMAKE_SOURCE_DIR}/contrib/aho-corasick"
        "${CMAKE_SOURCE_DIR}/contrib/lc-btrie"
        "${CMAKE_SOURCE_DIR}/contrib/lua-lpeg"
        "${CMAKE_SOURCE_DIR}/contrib/frozen/include"
        "${CMAKE_SOURCE_DIR}/contrib/fu2/include"
        "${CMAKE_BINARY_DIR}/src" #Stored in the binary dir
        "${CMAKE_BINARY_DIR}/src/libcryptobox")

SET(TAR "tar")
INCLUDE(OSDep)

# Now find libraries and headers
LIST(APPEND RSPAMD_REQUIRED_LIBRARIES "m")
LIST(APPEND RSPAMD_REQUIRED_LIBRARIES "pthread")

IF (ENABLE_LUAJIT MATCHES "ON")
    ProcessPackage(LIBLUAJIT LIBRARY "luajit"
            "luajit-2.1"
            "luajit2.1"
            "luajit-2.0"
            "luajit2.0"
            "luajit-5.1"
            INCLUDE luajit.h INCLUDE_SUFFIXES
            "include/luajit-2.1"
            "include/luajit-2.0"
            "include/luajit"
            ROOT ${LUA_ROOT}
            MODULES luajit)
    SET(WITH_LUAJIT 1)
ELSE (ENABLE_LUAJIT MATCHES "ON")

    ProcessPackage(LIBLUA LIBRARY "lua"
            "lua-5.3"
            LIB_SUFFIXES "lua5.3"
            INCLUDE lua.h INCLUDE_SUFFIXES
            "include/lua-5.3"
            "include/lua5.3"
            "include/lua53"
            "include/lua"
            ROOT ${LUA_ROOT}
            MODULES lua53
            OPTIONAL)

    IF (NOT WITH_LIBLUA)
        ProcessPackage(LIBLUA LIBRARY "lua"
                "lua-5.4"
                LIB_SUFFIXES "lua5.4"
                INCLUDE lua.h INCLUDE_SUFFIXES
                "include/lua-5.4"
                "include/lua5.4"
                "include/lua54"
                "include/lua"
                ROOT ${LUA_ROOT}
                MODULES lua54
                OPTIONAL)
        IF (NOT WITH_LIBLUA)
            ProcessPackage(LIBLUA LIBRARY "lua"
                    "lua-5.2"
                    LIB_SUFFIXES "lua5.2"
                    INCLUDE lua.h INCLUDE_SUFFIXES
                    "include/lua-5.2"
                    "include/lua5.2"
                    "include/lua52"
                    "include/lua"
                    ROOT ${LUA_ROOT}
                    MODULES lua52
                    OPTIONAL)

            IF (NOT WITH_LIBLUA)
                ProcessPackage(LIBLUA LIBRARY "lua"
                        "lua-5.1"
                        INCLUDE lua.h INCLUDE_SUFFIXES
                        "include/lua-5.1"
                        "include/lua5.1"
                        "include/lua51"
                        "include/lua"
                        ROOT ${LUA_ROOT}
                        MODULES lua51)
            ENDIF ()
        ENDIF ()
    ENDIF ()
ENDIF (ENABLE_LUAJIT MATCHES "ON")

IF (ENABLE_JEMALLOC MATCHES "ON" AND NOT SANITIZE)
    ProcessPackage(JEMALLOC LIBRARY jemalloc_pic jemalloc INCLUDE jemalloc.h INCLUDE_SUFFIXES include/jemalloc
            ROOT ${JEMALLOC_ROOT_DIR})
    SET(WITH_JEMALLOC "1")
ENDIF ()

IF (ENABLE_LIBUNWIND MATCHES "ON")
    ProcessPackage(LIBUNWIND LIBRARY unwind INCLUDE libunwind.h INCLUDE_SUFFIXES include/libunwind
            ROOT ${LIBUNWIND_ROOT_DIR} MODULES libunwind)
    SET(WITH_LIBUNWIND "1")
ENDIF ()

ProcessPackage(GLIB2 LIBRARY glib-2.0 INCLUDE glib.h
        INCLUDE_SUFFIXES include/glib include/glib-2.0
        ROOT ${GLIB_ROOT_DIR} MODULES glib-2.0>=2.28)

IF (ENABLE_PCRE2 MATCHES "ON")
    ProcessPackage(PCRE LIBRARY pcre2 pcre2-8 INCLUDE pcre2.h INCLUDE_SUFFIXES include/pcre2
            ROOT ${PCRE_ROOT_DIR} MODULES pcre2 pcre2-8 libpcre2 libpcre2-8)
ELSE ()
    ProcessPackage(PCRE LIBRARY pcre INCLUDE pcre.h INCLUDE_SUFFIXES include/pcre
            ROOT ${PCRE_ROOT_DIR} MODULES pcre libpcre pcre3 libpcre3)
ENDIF ()

ProcessPackage(SQLITE3 LIBRARY sqlite3 INCLUDE sqlite3.h INCLUDE_SUFFIXES include/sqlite3 include/sqlite
        ROOT ${SQLITE3_ROOT_DIR} MODULES sqlite3 sqlite)
ProcessPackage(ICUDATA LIBRARY icudata INCLUDE unicode/ucnv.h
        ROOT ${ICU_ROOT_DIR} MODULES icu-uc)
ProcessPackage(ICUC LIBRARY icuuc INCLUDE unicode/ucnv.h
        ROOT ${ICU_ROOT_DIR} MODULES icu-uc)
ProcessPackage(ICUIO LIBRARY icuio INCLUDE unicode/ucnv.h
        ROOT ${ICU_ROOT_DIR} MODULES icu-io)
ProcessPackage(ICUI18N LIBRARY icui18n INCLUDE unicode/ucnv.h
        ROOT ${ICU_ROOT_DIR} MODULES icu-i18n)
ProcessPackage(LIBCRYPT LIBRARY crypto INCLUDE openssl/evp.h
        ROOT ${OPENSSL_ROOT_DIR} MODULES openssl libcrypt)
ProcessPackage(LIBSSL LIBRARY ssl INCLUDE openssl/ssl.h
        ROOT ${OPENSSL_ROOT_DIR} MODULES openssl libssl)
ProcessPackage(LIBZ LIBRARY z INCLUDE zlib.h INCLUDE_SUFFIXES include/zlib
        ROOT ${LIBZ_ROOT_DIR} MODULES z)
ProcessPackage(SODIUM LIBRARY sodium INCLUDE sodium.h
        INCLUDE_SUFFIXES include/libsodium include/sodium
        ROOT ${LIBSODIUM_ROOT_DIR} MODULES libsodium>=1.0.0)

if (ENABLE_FASTTEXT MATCHES "ON")
    ProcessPackage(FASTTEXT LIBRARY fasttext INCLUDE fasttext.h
            INCLUDE_SUFFIXES include/fasttext
            ROOT ${FASTTEXT_ROOT_DIR} MODULES fasttext)
    SET(WITH_FASTTEXT "1")
endif ()

include(CompilerWarnings)
include(Hyperscan)
include(Openblas)

IF (ENABLE_LUA_TRACE)
    SET(WITH_LUA_TRACE 1)
ENDIF (ENABLE_LUA_TRACE)

SET(CMAKE_C_FLAGS "${CMAKE_C_OPT_FLAGS} ${CMAKE_C_FLAGS}")
SET(CMAKE_CXX_FLAGS "${CMAKE_C_OPT_FLAGS} ${CMAKE_CXX_FLAGS}")

ADD_DEFINITIONS(-DHAVE_CONFIG_H)
ADD_DEFINITIONS(-DDOCTEST_CONFIG_NO_MULTI_LANE_ATOMICS)
ADD_DEFINITIONS(-DFMT_HEADER_ONLY)
# Workaround for https://github.com/onqtam/doctest/issues/356
ADD_DEFINITIONS(-DDOCTEST_CONFIG_USE_STD_HEADERS)
ADD_DEFINITIONS(-DU_CHARSET_IS_UTF8)

# Check platform specific includes
CHECK_INCLUDE_FILES(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(sys/uio.h HAVE_SYS_UIO_H)

CHECK_INCLUDE_FILES(fcntl.h HAVE_FCNTL_H)
CHECK_INCLUDE_FILES(math.h HAVE_MATH_H)
CHECK_INCLUDE_FILES(stdio.h HAVE_STDIO_H)
CHECK_INCLUDE_FILES(stdlib.h HAVE_STDLIB_H)
CHECK_INCLUDE_FILES(string.h HAVE_STRING_H)
CHECK_INCLUDE_FILES(strings.h HAVE_STRINGS_H)
CHECK_INCLUDE_FILES(time.h HAVE_TIME_H)
CHECK_INCLUDE_FILES(unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES(stdint.h HAVE_STDINT_H)
CHECK_INCLUDE_FILES(inttypes.h HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES(stdbool.h HAVE_STDBOOL_H)
CHECK_INCLUDE_FILES(endian.h HAVE_ENDIAN_H)
CHECK_INCLUDE_FILES(sys/endian.h HAVE_SYS_ENDIAN_H)
CHECK_INCLUDE_FILES(machine/endian.h HAVE_MACHINE_ENDIAN_H)
CHECK_INCLUDE_FILES(sys/socket.h HAVE_SYS_SOCKET_H)
CHECK_INCLUDE_FILES(sys/mman.h HAVE_SYS_MMAN_H)
CHECK_INCLUDE_FILES(sys/un.h HAVE_SYS_UN_H)
CHECK_INCLUDE_FILES(sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES(sys/wait.h HAVE_SYS_WAIT_H)
CHECK_INCLUDE_FILES(sys/param.h HAVE_SYS_PARAM_H)
CHECK_INCLUDE_FILES(sys/file.h HAVE_SYS_FILE_H)
CHECK_INCLUDE_FILES(sys/resource.h HAVE_SYS_RESOURCE_H)
CHECK_INCLUDE_FILES(netinet/in.h HAVE_NETINET_IN_H)
CHECK_INCLUDE_FILES(netinet/tcp.h HAVE_NETINET_TCP_H)
CHECK_INCLUDE_FILES(arpa/inet.h HAVE_ARPA_INET_H)
CHECK_INCLUDE_FILES(netdb.h HAVE_NETDB_H)
CHECK_INCLUDE_FILES(syslog.h HAVE_SYSLOG_H)
CHECK_INCLUDE_FILES(siginfo.h HAVE_SIGINFO_H)
CHECK_INCLUDE_FILES(locale.h HAVE_LOCALE_H)
CHECK_INCLUDE_FILES(libgen.h HAVE_LIBGEN_H)
CHECK_INCLUDE_FILES(pwd.h HAVE_PWD_H)
CHECK_INCLUDE_FILES(grp.h HAVE_GRP_H)
CHECK_INCLUDE_FILES(glob.h HAVE_GLOB_H)
CHECK_INCLUDE_FILES(poll.h HAVE_POLL_H)
CHECK_INCLUDE_FILES(readpassphrase.h HAVE_READPASSPHRASE_H)
CHECK_INCLUDE_FILES(termios.h HAVE_TERMIOS_H)
CHECK_INCLUDE_FILES(paths.h HAVE_PATHS_H)
CHECK_INCLUDE_FILES(ctype.h HAVE_CTYPE_H)
CHECK_INCLUDE_FILES(unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES(cpuid.h HAVE_CPUID_H)
CHECK_INCLUDE_FILES(dirent.h HAVE_DIRENT_H)
CHECK_INCLUDE_FILES(ucontext.h HAVE_UCONTEXT_H)

=== src/CMakeLists.txt ===
MACRO(_AddModulesForced MLIST)
# Generate unique string for this build
	SET(MODULES_C "${CMAKE_CURRENT_BINARY_DIR}/modules.c")
	FILE(WRITE "${MODULES_C}"
		"#include \"rspamd.h\"\n")

	# Handle even old cmake
	LIST(LENGTH ${MLIST} MLIST_COUNT)
	MATH(EXPR MLIST_MAX ${MLIST_COUNT}-1)

	FOREACH(MOD_IDX RANGE ${MLIST_MAX})
		LIST(GET ${MLIST} ${MOD_IDX} MOD)
		FILE(APPEND "${MODULES_C}" "extern module_t ${MOD}_module;\n")
	ENDFOREACH(MOD_IDX RANGE ${MLIST_MAX})

	FILE(APPEND "${MODULES_C}" "\n\nmodule_t *modules[] = {\n")

	FOREACH(MOD_IDX RANGE ${MLIST_MAX})
		LIST(GET ${MLIST} ${MOD_IDX} MOD)
		FILE(APPEND "${MODULES_C}" "&${MOD}_module,\n")
	ENDFOREACH(MOD_IDX RANGE ${MLIST_MAX})

	FILE(APPEND "${MODULES_C}" "NULL\n};\n")
ENDMACRO(_AddModulesForced MLIST)

MACRO(_AddWorkersForced WLIST)
	SET(WORKERS_C "${CMAKE_CURRENT_BINARY_DIR}/workers.c")
	FILE(WRITE "${WORKERS_C}"
		"#include \"rspamd.h\"\n")

	# Handle even old cmake
	LIST(LENGTH ${WLIST} WLIST_COUNT)
	MATH(EXPR WLIST_MAX ${WLIST_COUNT}-1)
	FOREACH(MOD_IDX RANGE ${WLIST_MAX})
		LIST(GET ${WLIST} ${MOD_IDX} WRK)
		FILE(APPEND "${WORKERS_C}" "extern worker_t ${WRK}_worker;\n")
	ENDFOREACH(MOD_IDX RANGE ${WLIST_MAX})

	FILE(APPEND "${WORKERS_C}" "\n\nworker_t *workers[] = {\n")

	FOREACH(MOD_IDX RANGE ${WLIST_MAX})
		LIST(GET ${WLIST} ${MOD_IDX} WRK)
		FILE(APPEND "${WORKERS_C}" "&${WRK}_worker,\n")
	ENDFOREACH(MOD_IDX RANGE ${WLIST_MAX})
	FILE(APPEND "${WORKERS_C}" "NULL\n};\n")
ENDMACRO(_AddWorkersForced WLIST)

MACRO(AddModules MLIST WLIST)
	_AddModulesForced(${MLIST})
	_AddWorkersForced(${WLIST})
	#IF(NOT EXISTS "modules.c")
	#	_AddModulesForced(${MLIST} ${WLIST})
	#ELSE(NOT EXISTS "modules.c")
	#	FILE(STRINGS "modules.c" FILE_ID_RAW REGEX "^/.*[a-zA-Z0-9]+.*/$")
	#	STRING(REGEX MATCH "[a-zA-Z0-9]+" FILE_ID "${FILE_ID_RAW}")
	#	IF(NOT FILE_ID STREQUAL MODULES_ID)
	#		MESSAGE("Regenerate modules info")
	#		_AddModulesForced(${MLIST} ${WLIST})
	#	ENDIF(NOT FILE_ID STREQUAL MODULES_ID)
	#ENDIF(NOT EXISTS "modules.c")
ENDMACRO(AddModules MLIST WLIST)

# Rspamd core components
IF (ENABLE_CLANG_PLUGIN MATCHES "ON")
	SET(CMAKE_C_FLAGS
			"${CMAKE_C_FLAGS} -Xclang -load -Xclang ${CMAKE_CURRENT_BINARY_DIR}/../clang-plugin/librspamd-clang${CMAKE_SHARED_LIBRARY_SUFFIX} -Xclang -add-plugin -Xclang rspamd-ast")
	IF(CLANG_EXTRA_PLUGINS_LIBS)
		FOREACH(_lib ${CLANG_EXTRA_PLUGINS_LIBS})
			SET(CMAKE_C_FLAGS
					"${CMAKE_C_FLAGS} -Xclang -load -Xclang ${_lib}")
			SET(CMAKE_CXX_FLAGS
					"${CMAKE_CXX_FLAGS} -Xclang -load -Xclang ${_lib}")
		ENDFOREACH()
	ENDIF()
	IF(CLANG_EXTRA_PLUGINS)
		FOREACH(_plug ${CLANG_EXTRA_PLUGINS})
			SET(CMAKE_C_FLAGS
					"${CMAKE_C_FLAGS} -Xclang -add-plugin -Xclang ${_plug}")
			SET(CMAKE_CXX_FLAGS
					"${CMAKE_C_FLAGS} -Xclang -add-plugin -Xclang ${_plug}")
		ENDFOREACH()
	ENDIF()
ENDIF ()

ADD_SUBDIRECTORY(lua)
ADD_SUBDIRECTORY(libcryptobox)
ADD_SUBDIRECTORY(libutil)
ADD_SUBDIRECTORY(libserver)
ADD_SUBDIRECTORY(libmime)
ADD_SUBDIRECTORY(libstat)
ADD_SUBDIRECTORY(client)
ADD_SUBDIRECTORY(rspamadm)

SET(RSPAMDSRC	controller.c
				fuzzy_storage.c
				rspamd.c
				worker.c
				rspamd_proxy.c)

SET(PLUGINSSRC  plugins/regexp.c
		plugins/chartable.cxx
				plugins/fuzzy_check.c
				plugins/dkim_check.c
				libserver/rspamd_control.c)

SET(MODULES_LIST regexp chartable fuzzy_check dkim)
SET(WORKERS_LIST normal controller fuzzy rspamd_proxy)
IF (ENABLE_HYPERSCAN MATCHES "ON")
	LIST(APPEND WORKERS_LIST "hs_helper")
	LIST(APPEND RSPAMDSRC "hs_helper.c")
ENDIF()

AddModules(MODULES_LIST WORKERS_LIST)
LIST(LENGTH PLUGINSSRC RSPAMD_MODULES_NUM)

SET(RAGEL_DEPENDS "${CMAKE_SOURCE_DIR}/src/ragel/smtp_address.rl"
	"${CMAKE_SOURCE_DIR}/src/ragel/smtp_date.rl"
	"${CMAKE_SOURCE_DIR}/src/ragel/smtp_ip.rl"
	"${CMAKE_SOURCE_DIR}/src/ragel/smtp_base.rl"
	"${CMAKE_SOURCE_DIR}/src/ragel/content_disposition.rl")
RAGEL_TARGET(ragel_smtp_addr
	INPUTS ${CMAKE_SOURCE_DIR}/src/ragel/smtp_addr_parser.rl
	DEPENDS ${RAGEL_DEPENDS}
	COMPILE_FLAGS -T1
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/smtp_addr_parser.rl.c)
RAGEL_TARGET(ragel_content_disposition
	INPUTS ${CMAKE_SOURCE_DIR}/src/ragel/content_disposition_parser.rl
	DEPENDS ${RAGEL_DEPENDS}
	COMPILE_FLAGS -G2
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/content_disposition.rl.c)
RAGEL_TARGET(ragel_rfc2047
	INPUTS ${CMAKE_SOURCE_DIR}/src/ragel/rfc2047_parser.rl
	DEPENDS ${RAGEL_DEPENDS}
	COMPILE_FLAGS -G2
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rfc2047.rl.c)
RAGEL_TARGET(ragel_smtp_date
	INPUTS ${CMAKE_SOURCE_DIR}/src/ragel/smtp_date_parser.rl
	DEPENDS ${RAGEL_DEPENDS}
	COMPILE_FLAGS -G2
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/date_parser.rl.c)
RAGEL_TARGET(ragel_smtp_ip
	INPUTS ${CMAKE_SOURCE_DIR}/src/ragel/smtp_ip_parser.rl
	DEPENDS ${RAGEL_DEPENDS}
	COMPILE_FLAGS -G2
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ip_parser.rl.c)
# Fucking cmake...
FOREACH(_GEN ${LIBSERVER_GENERATED})
	set_source_files_properties(${_GEN} PROPERTIES GENERATED TRUE)
ENDFOREACH()
######################### LINK SECTION ###############################

IF(ENABLE_STATIC MATCHES "ON")
	ADD_LIBRARY(rspamd-server STATIC
			${RSPAMD_CRYPTOBOX}
			${RSPAMD_UTIL}
			${RSPAMD_LUA}
			${RSPAMD_SERVER}
			${RSPAMD_STAT}
			${RSPAMD_MIME}
			${CMAKE_CURRENT_BINARY_DIR}/modules.c
			${PLUGINSSRC}
			"${RAGEL_ragel_smtp_addr_OUTPUTS}"
			"${RAGEL_ragel_newlines_strip_OUTPUTS}"
			"${RAGEL_ragel_content_type_OUTPUTS}"
			"${RAGEL_ragel_content_disposition_OUTPUTS}"
			"${RAGEL_ragel_rfc2047_OUTPUTS}"
			"${RAGEL_ragel_smtp_date_OUTPUTS}"
			"${RAGEL_ragel_smtp_ip_OUTPUTS}")
ELSE()
	ADD_LIBRARY(rspamd-server SHARED
			${RSPAMD_CRYPTOBOX}
			${RSPAMD_UTIL}
			${RSPAMD_SERVER}
			${RSPAMD_STAT}
			${RSPAMD_MIME}
			${RSPAMD_LUA}
			${CMAKE_CURRENT_BINARY_DIR}/modules.c
			${PLUGINSSRC}
			"${RAGEL_ragel_smtp_addr_OUTPUTS}"
			"${RAGEL_ragel_newlines_strip_OUTPUTS}"
			"${RAGEL_ragel_content_type_OUTPUTS}"
			"${RAGEL_ragel_content_disposition_OUTPUTS}"
			"${RAGEL_ragel_rfc2047_OUTPUTS}"
			"${RAGEL_ragel_smtp_date_OUTPUTS}"
			"${RAGEL_ragel_smtp_ip_OUTPUTS}")
ENDIF()

FOREACH(_DEP ${LIBSERVER_DEPENDS})
	ADD_DEPENDENCIES(rspamd-server "${_DEP}")
ENDFOREACH()

TARGET_LINK_LIBRARIES(rspamd-server rspamd-http-parser)
TARGET_LINK_LIBRARIES(rspamd-server rspamd-fpconv)
TARGET_LINK_LIBRARIES(rspamd-server rspamd-cdb)
TARGET_LINK_LIBRARIES(rspamd-server rspamd-lpeg)
TARGET_LINK_LIBRARIES(rspamd-server lcbtrie)
IF(SYSTEM_ZSTD MATCHES "OFF")
	TARGET_LINK_LIBRARIES(rspamd-server rspamd-zstd)
ELSE()
	TARGET_LINK_LIBRARIES(rspamd-server zstd)
ENDIF()
TARGET_LINK_LIBRARIES(rspamd-server rspamd-fastutf8)

IF (ENABLE_CLANG_PLUGIN MATCHES "ON")
	ADD_DEPENDENCIES(rspamd-server rspamd-clang)
ENDIF()

IF (NOT WITH_LUAJIT)
	TARGET_LINK_LIBRARIES(rspamd-server rspamd-bit)
ENDIF()

IF (ENABLE_SNOWBALL MATCHES "ON")
	TARGET_LINK_LIBRARIES(rspamd-server stemmer)
ENDIF()
TARGET_LINK_LIBRARIES(rspamd-server rspamd-hiredis)

IF (ENABLE_FANN MATCHES "ON")
	TARGET_LINK_LIBRARIES(rspamd-server fann)
ENDIF ()

IF (ENABLE_HYPERSCAN MATCHES "ON")
	TARGET_LINK_LIBRARIES(rspamd-server hs)
ENDIF()

IF(WITH_BLAS)
	TARGET_LINK_LIBRARIES(rspamd-server ${BLAS_REQUIRED_LIBRARIES})
ENDIF()

TARGET_LINK_LIBRARIES(rspamd-server ${RSPAMD_REQUIRED_LIBRARIES})

ADD_EXECUTABLE(rspamd ${RSPAMDSRC} ${CMAKE_CURRENT_BINARY_DIR}/workers.c ${CMAKE_CURRENT_BINARY_DIR}/config.h)
SET_TARGET_PROPERTIES(rspamd PROPERTIES LINKER_LANGUAGE CXX)
SET_TARGET_PROPERTIES(rspamd-server PROPERTIES LINKER_LANGUAGE CXX)
IF(NOT DEBIAN_BUILD)
	SET_TARGET_PROPERTIES(rspamd PROPERTIES VERSION ${RSPAMD_VERSION})
ENDIF(NOT DEBIAN_BUILD)

#TARGET_LINK_LIBRARIES(rspamd ${RSPAMD_REQUIRED_LIBRARIES})
TARGET_LINK_LIBRARIES(rspamd rspamd-server)

INSTALL(TARGETS rspamd RUNTIME DESTINATION bin)
INSTALL(TARGETS rspamd-server LIBRARY DESTINATION ${RSPAMD_LIBDIR})

=== src/rspamadm/CMakeLists.txt ===
SET(RSPAMADMSRC rspamadm.c
        commands.c
        pw.c
        configtest.c
        fuzzy_convert.c
        configdump.c
        control.c
        confighelp.c
        stat_convert.c
        signtool.c
        lua_repl.c
        ${CMAKE_BINARY_DIR}/src/workers.c
        #${CMAKE_BINARY_DIR}/src/modules.c - defined in rspamdserver
        ${CMAKE_SOURCE_DIR}/src/controller.c
        ${CMAKE_SOURCE_DIR}/src/fuzzy_storage.c
        ${CMAKE_SOURCE_DIR}/src/worker.c
        ${CMAKE_SOURCE_DIR}/src/rspamd_proxy.c)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
IF (ENABLE_HYPERSCAN MATCHES "ON")
    LIST(APPEND RSPAMADMSRC "${CMAKE_SOURCE_DIR}/src/hs_helper.c")
ENDIF()
ADD_EXECUTABLE(rspamadm ${RSPAMADMSRC})
TARGET_LINK_LIBRARIES(rspamadm rspamd-server)

IF (NOT DEBIAN_BUILD)
    SET_TARGET_PROPERTIES(rspamadm PROPERTIES VERSION ${RSPAMD_VERSION})
ENDIF (NOT DEBIAN_BUILD)

SET_TARGET_PROPERTIES(rspamadm PROPERTIES LINKER_LANGUAGE CXX)
INSTALL(TARGETS rspamadm RUNTIME DESTINATION bin)

=== debian/changelog ===
rspamd (3.6-1ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: remove -Wl,-Bsymbolic-functions from linker flags if
      building on ubuntu and for armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 11 Aug 2023 11:56:41 +0200

rspamd (3.6-1) unstable; urgency=medium

  * New upstream version 3.6
  * lintian: update version number
  * d/patches: refresh patches

 -- Sebastien Badia <sbadia@debian.org>  Tue, 08 Aug 2023 21:14:35 +0200

rspamd (3.5-1ubuntu3) mantic; urgency=medium

  * Link latomic on riscv64 to fix a build failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 31 Jul 2023 08:40:39 +0200

rspamd (3.5-1ubuntu1) mantic; urgency=medium

  * d/rules: remove -Wl,-Bsymbolic-functions from linker flags if
    building on ubuntu and for armhf (LP: #2027879)

 -- Andreas Hasenack <andreas@canonical.com>  Mon, 17 Jul 2023 17:13:27 -0300

rspamd (3.5-1) unstable; urgency=medium

  * d/copyright: Update Vsevolod email
  * New upstream version 3.5 (Closes: #1037486, #1037849, #1036646)
  * d/patches:
    + removed upstream patches
    + refresh patches according new upstream

 -- Sebastien Badia <sbadia@debian.org>  Sun, 25 Jun 2023 01:22:24 +0200

## rspamd 3.7.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,18 +8,20 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.12 FATAL_ERROR)
 
 SET(RSPAMD_VERSION_MAJOR 3)
-SET(RSPAMD_VERSION_MINOR 6)
+SET(RSPAMD_VERSION_MINOR 7)
+SET(RSPAMD_VERSION_PATCH 3)
 
 # Keep two digits all the time
 SET(RSPAMD_VERSION_MAJOR_NUM ${RSPAMD_VERSION_MAJOR}0)
 SET(RSPAMD_VERSION_MINOR_NUM ${RSPAMD_VERSION_MINOR}0)
+SET(RSPAMD_VERSION_PATCH_NUM ${RSPAMD_VERSION_PATCH}0)
 
 IF (GIT_ID)
     SET(GIT_VERSION 1)
     SET(RSPAMD_ID "${GIT_ID}")
 ENDIF ()
 
-SET(RSPAMD_VERSION "${RSPAMD_VERSION_MAJOR}.${RSPAMD_VERSION_MINOR}")
+SET(RSPAMD_VERSION "${RSPAMD_VERSION_MAJOR}.${RSPAMD_VERSION_MINOR}.${RSPAMD_VERSION_PATCH}")
 
 PROJECT(rspamd VERSION "${RSPAMD_VERSION}" LANGUAGES C CXX ASM)
 
@@ -54,10 +56,11 @@
 OPTION(ENABLE_PCRE2 "Enable pcre2 instead of pcre  [default: ON]" ON)
 OPTION(ENABLE_JEMALLOC "Build rspamd with jemalloc allocator  [default: OFF]" OFF)
 OPTION(ENABLE_UTILS "Build rspamd internal utils [default: OFF]" OFF)
-OPTION(ENABLE_LIBUNWIND "Use libunwind to print crash traces [default: OFF]" OFF)
+OPTION(ENABLE_LIBUNWIND "Obsoleted [default: OFF]" OFF)
 OPTION(ENABLE_LUA_TRACE "Trace all Lua C API invocations [default: OFF]" OFF)
 OPTION(ENABLE_LUA_REPL "Enables Lua repl (requires C++11 compiler) [default: ON]" ON)
 OPTION(ENABLE_FASTTEXT "Link with FastText library [default: OFF]" OFF)
+OPTION(ENABLE_BACKWARD "Build rspamd with backward-cpp stacktrace [default: ON]" ON)
 OPTION(SYSTEM_ZSTD "Use system zstd instead of bundled one [default: OFF]" OFF)
 OPTION(SYSTEM_FMT "Use system fmt instead of bundled one [default: OFF]" OFF)
 OPTION(SYSTEM_DOCTEST "Use system doctest instead of bundled one [default: OFF]" OFF)
@@ -204,12 +207,6 @@
     ProcessPackage(JEMALLOC LIBRARY jemalloc_pic jemalloc INCLUDE jemalloc.h INCLUDE_SUFFIXES include/jemalloc
             ROOT ${JEMALLOC_ROOT_DIR})
     SET(WITH_JEMALLOC "1")
-ENDIF ()
-
-IF (ENABLE_LIBUNWIND MATCHES "ON")
-    ProcessPackage(LIBUNWIND LIBRARY unwind INCLUDE libunwind.h INCLUDE_SUFFIXES include/libunwind
-            ROOT ${LIBUNWIND_ROOT_DIR} MODULES libunwind)
-    SET(WITH_LIBUNWIND "1")
 ENDIF ()
 
 ProcessPackage(GLIB2 LIBRARY glib-2.0 INCLUDE glib.h
@@ -315,3 +312,6 @@
 CHECK_INCLUDE_FILES(cpuid.h HAVE_CPUID_H)
 CHECK_INCLUDE_FILES(dirent.h HAVE_DIRENT_H)
 CHECK_INCLUDE_FILES(ucontext.h HAVE_UCONTEXT_H)
+CHECK_INCLUDE_FILES(sys/ucontext.h HAVE_SYS_UCONTEXT_H) # OSX specific
+
+# Check platform API

=== debian/changelog ===
rspamd (3.7.3-1ubuntu2) noble; urgency=medium

  * No-change rebuild for ICU soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 11:07:54 +0100

rspamd (3.7.3-1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: remove -Wl,-Bsymbolic-functions from linker flags if
      building on ubuntu and for armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 29 Oct 2023 08:46:03 +0100

rspamd (3.7.3-1) unstable; urgency=medium

  * New upstream version 3.7.3

 -- Sebastien Badia <sbadia@debian.org>  Sat, 28 Oct 2023 00:14:48 +0200

rspamd (3.7.2-1) unstable; urgency=medium

  * New upstream version 3.7.2
  * d/patches: refresh patches

 -- Sebastien Badia <sbadia@debian.org>  Thu, 26 Oct 2023 22:33:03 +0200

rspamd (3.7.1-1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/rules: remove -Wl,-Bsymbolic-functions from linker flags if
      building on ubuntu and for armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 26 Oct 2023 09:14:31 +0200

rspamd (3.7.1-1) unstable; urgency=medium

  * New upstream version 3.7.1
  * d/patches: refresh patches (bootstrap 5.3.1, jquery 3.7.0)
  * d/lintian: update version number

 -- Sebastien Badia <sbadia@debian.org>  Tue, 10 Oct 2023 14:52:39 +0200

## rspamd 3.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,8 +8,8 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.12 FATAL_ERROR)
 
 SET(RSPAMD_VERSION_MAJOR 3)
-SET(RSPAMD_VERSION_MINOR 7)
-SET(RSPAMD_VERSION_PATCH 3)
+SET(RSPAMD_VERSION_MINOR 8)
+SET(RSPAMD_VERSION_PATCH 1)
 
 # Keep two digits all the time
 SET(RSPAMD_VERSION_MAJOR_NUM ${RSPAMD_VERSION_MAJOR}0)
@@ -242,8 +242,7 @@
         ROOT ${LIBSODIUM_ROOT_DIR} MODULES libsodium>=1.0.0)
 
 if (ENABLE_FASTTEXT MATCHES "ON")
-    ProcessPackage(FASTTEXT LIBRARY fasttext INCLUDE fasttext.h
-            INCLUDE_SUFFIXES include/fasttext
+    ProcessPackage(FASTTEXT LIBRARY fasttext INCLUDE fasttext/fasttext.h
             ROOT ${FASTTEXT_ROOT_DIR} MODULES fasttext)
     SET(WITH_FASTTEXT "1")
 endif ()
@@ -315,3 +314,4 @@
 CHECK_INCLUDE_FILES(sys/ucontext.h HAVE_SYS_UCONTEXT_H) # OSX specific
 
 # Check platform API
+IF(NOT CMAKE_SYSTEM_NAME STREQUAL "Linux")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -165,7 +165,8 @@
 			"${RAGEL_ragel_content_disposition_OUTPUTS}"
 			"${RAGEL_ragel_rfc2047_OUTPUTS}"
 			"${RAGEL_ragel_smtp_date_OUTPUTS}"
-			"${RAGEL_ragel_smtp_ip_OUTPUTS}")
+			"${RAGEL_ragel_smtp_ip_OUTPUTS}"
+			${BACKWARD_ENABLE})
 ELSE()
 	ADD_LIBRARY(rspamd-server SHARED
 			${RSPAMD_CRYPTOBOX}
@@ -182,7 +183,8 @@
 			"${RAGEL_ragel_content_disposition_OUTPUTS}"
 			"${RAGEL_ragel_rfc2047_OUTPUTS}"
 			"${RAGEL_ragel_smtp_date_OUTPUTS}"
-			"${RAGEL_ragel_smtp_ip_OUTPUTS}")
+			"${RAGEL_ragel_smtp_ip_OUTPUTS}"
+			${BACKWARD_ENABLE})
 ENDIF()
 
 FOREACH(_DEP ${LIBSERVER_DEPENDS})
@@ -227,8 +229,10 @@
 ENDIF()
 
 TARGET_LINK_LIBRARIES(rspamd-server ${RSPAMD_REQUIRED_LIBRARIES})
+ADD_BACKWARD(rspamd-server)
 
 ADD_EXECUTABLE(rspamd ${RSPAMDSRC} ${CMAKE_CURRENT_BINARY_DIR}/workers.c ${CMAKE_CURRENT_BINARY_DIR}/config.h)
+ADD_BACKWARD(rspamd)
 SET_TARGET_PROPERTIES(rspamd PROPERTIES LINKER_LANGUAGE CXX)
 SET_TARGET_PROPERTIES(rspamd-server PROPERTIES LINKER_LANGUAGE CXX)
 IF(NOT DEBIAN_BUILD)

=== contrib/backward-cpp/CMakeLists.txt ===
#
# CMakeLists.txt
# Copyright 2013 Google Inc. All Rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 3.0)
project(backward CXX)

# Introduce variables:
# * CMAKE_INSTALL_LIBDIR
# * CMAKE_INSTALL_BINDIR
# * CMAKE_INSTALL_INCLUDEDIR
include(GNUInstallDirs)

include(BackwardConfig.cmake)

# check if compiler is nvcc or nvcc_wrapper
set(COMPILER_IS_NVCC false)
get_filename_component(COMPILER_NAME ${CMAKE_CXX_COMPILER} NAME)
if (COMPILER_NAME MATCHES "^nvcc")
  set(COMPILER_IS_NVCC true)
endif()

if (DEFINED ENV{OMPI_CXX} OR DEFINED ENV{MPICH_CXX})
   if ( ($ENV{OMPI_CXX} MATCHES "nvcc") OR ($ENV{MPICH_CXX} MATCHES "nvcc") )
     set(COMPILER_IS_NVCC true)
   endif()
endif()

# set CXX standard
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 11)
if (${COMPILER_IS_NVCC})
  # GNU CXX extensions are not supported by nvcc
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

###############################################################################
# COMPILER FLAGS
###############################################################################

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
	if (NOT ${COMPILER_IS_NVCC})
	  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic-errors")
	endif()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif()

###############################################################################
# BACKWARD OBJECT
###############################################################################

add_library(backward_object OBJECT backward.cpp)
target_compile_definitions(backward_object PRIVATE ${BACKWARD_DEFINITIONS})
target_include_directories(backward_object PRIVATE ${BACKWARD_INCLUDE_DIRS})
set(BACKWARD_ENABLE $<TARGET_OBJECTS:backward_object> CACHE STRING
	"Link with this object to setup backward automatically")


###############################################################################
# BACKWARD LIBRARY (Includes backward.cpp)
###############################################################################
option(BACKWARD_SHARED "Build dynamic backward-cpp shared lib" OFF)

if(BACKWARD_SHARED)
    set(libtype SHARED)
endif()
add_library(backward ${libtype} backward.cpp)
target_compile_definitions(backward PUBLIC ${BACKWARD_DEFINITIONS})
target_include_directories(backward PUBLIC ${BACKWARD_INCLUDE_DIRS})

=== contrib/doctest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

if(POLICY CMP0077)
    cmake_policy(SET CMP0077 NEW)
endif()

################################################################################
## DOCTEST
################################################################################

project(doctest VERSION 2.4.6 LANGUAGES CXX)

# Determine if doctest is built as a subproject (using add_subdirectory) or if it is the main project.
set(MAIN_PROJECT OFF)
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(MAIN_PROJECT ON)
endif()

option(DOCTEST_WITH_TESTS               "Build tests/examples" ${MAIN_PROJECT})
option(DOCTEST_WITH_MAIN_IN_STATIC_LIB  "Build a static lib (cmake target) with a default main entry point" ON)
option(DOCTEST_NO_INSTALL  "Skip the installation process" OFF)
option(DOCTEST_USE_STD_HEADERS  "Use std headers" OFF)

add_library(${PROJECT_NAME} INTERFACE)
add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

if(NOT CMAKE_VERSION VERSION_LESS 3.8)
    target_compile_features(${PROJECT_NAME} INTERFACE cxx_std_11)
endif()

set(doctest_parts_folder "${CMAKE_CURRENT_SOURCE_DIR}/doctest/parts")
set(doctest_folder "${CMAKE_CURRENT_SOURCE_DIR}/") # in order to have the mpi extension files, not included into the doctest.h single header

if(MAIN_PROJECT)
    # use a special hidden version of the header which directly includes the 2 parts - proper reporting of file/line locations during dev
    target_include_directories(${PROJECT_NAME} INTERFACE
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/scripts/development_only/>
        $<BUILD_INTERFACE:${doctest_parts_folder}>
        $<BUILD_INTERFACE:${doctest_folder}>)

    # add a custom target that assembles the single header when any of the parts are touched
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/doctest/doctest.h
        DEPENDS
            ${doctest_parts_folder}/doctest_fwd.h
            ${doctest_parts_folder}/doctest.cpp
        COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_SOURCE_DIR}/scripts/cmake/assemble_single_header.cmake
        COMMENT "assembling the single header")

    add_custom_target(assemble_single_header ALL DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/doctest/doctest.h)
else()
    target_include_directories(${PROJECT_NAME} INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/>)
endif()

# hack to support building on XCode 6 and 7 - propagate the definition to everything
if(DEFINED DOCTEST_THREAD_LOCAL)
    target_compile_definitions(${PROJECT_NAME} INTERFACE
        DOCTEST_THREAD_LOCAL=${DOCTEST_THREAD_LOCAL})
endif()

if(DOCTEST_USE_STD_HEADERS)
    target_compile_definitions(${PROJECT_NAME} INTERFACE DOCTEST_CONFIG_USE_STD_HEADERS)
endif()

=== contrib/fastutf8/CMakeLists.txt ===
SET(UTFSRC ${CMAKE_CURRENT_SOURCE_DIR}/fastutf8.c)
IF(HAVE_AVX2 AND "${ARCH}" STREQUAL "x86_64")
    SET(UTFSRC ${UTFSRC} ${CMAKE_CURRENT_SOURCE_DIR}/avx2.c)
    MESSAGE(STATUS "UTF8: AVX2 support is added")
ENDIF()
IF(HAVE_SSE41 AND "${ARCH}" STREQUAL "x86_64")
    SET(UTFSRC ${UTFSRC} ${CMAKE_CURRENT_SOURCE_DIR}/sse41.c)
    MESSAGE(STATUS "UTF8: SSE41 support is added")
ENDIF()

ADD_LIBRARY(rspamd-fastutf8 STATIC ${UTFSRC})

=== contrib/libucl/CMakeLists.txt ===
SET(UCLSRC            ucl_util.c
                      ucl_parser.c
                      ucl_emitter.c
                      ucl_emitter_streamline.c
                      ucl_hash.c
                      ucl_schema.c
                      lua_ucl.c
					  ucl_msgpack.c
					  ucl_sexp.c)


SET (LIB_TYPE STATIC)
ADD_LIBRARY(ucl ${LIB_TYPE} ${UCLSRC})

IF(ENABLE_URL_SIGN MATCHES "ON")
	IF(OPENSSL_FOUND)
		TARGET_LINK_LIBRARIES(ucl ${OPENSSL_LIBRARIES})
	ENDIF(OPENSSL_FOUND)
ENDIF(ENABLE_URL_SIGN MATCHES "ON")

=== contrib/xxhash/CMakeLists.txt ===
SET(XXHASHSRC xxhash.c)

ADD_LIBRARY(xxhash STATIC ${XXHASHSRC})

IF(ENABLE_FULL_DEBUG MATCHES "OFF")
if ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
	SET_TARGET_PROPERTIES(xxhash PROPERTIES COMPILE_FLAGS "-O3")
endif ()
else()
ADD_DEFINITIONS(-DXXH_NO_INLINE_HINTS=1)
ENDIF()

set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DXXH_NO_INLINE_HINTS=1" PARENT_SCOPE)

=== src/libserver/CMakeLists.txt ===
# Librspamdserver
ADD_SUBDIRECTORY(css)
SET(LIBRSPAMDSERVERSRC
        ${CMAKE_CURRENT_SOURCE_DIR}/cfg_utils.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/cfg_rcl.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/composites/composites.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/composites/composites_manager.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/dkim.c
        ${CMAKE_CURRENT_SOURCE_DIR}/dns.c
        ${CMAKE_CURRENT_SOURCE_DIR}/dynamic_cfg.c
        ${CMAKE_CURRENT_SOURCE_DIR}/async_session.c
        ${CMAKE_CURRENT_SOURCE_DIR}/fuzzy_backend/fuzzy_backend.c
        ${CMAKE_CURRENT_SOURCE_DIR}/fuzzy_backend/fuzzy_backend_sqlite.c
        ${CMAKE_CURRENT_SOURCE_DIR}/fuzzy_backend/fuzzy_backend_redis.c
        ${CMAKE_CURRENT_SOURCE_DIR}/milter.c
        ${CMAKE_CURRENT_SOURCE_DIR}/monitored.c
        ${CMAKE_CURRENT_SOURCE_DIR}/protocol.c
        ${CMAKE_CURRENT_SOURCE_DIR}/re_cache.c
        ${CMAKE_CURRENT_SOURCE_DIR}/redis_pool.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/roll_history.c
        ${CMAKE_CURRENT_SOURCE_DIR}/spf.c
        ${CMAKE_CURRENT_SOURCE_DIR}/ssl_util.c
        ${CMAKE_CURRENT_SOURCE_DIR}/symcache/symcache_impl.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/symcache/symcache_item.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/symcache/symcache_runtime.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/symcache/symcache_c.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/task.c
        ${CMAKE_CURRENT_SOURCE_DIR}/url.c
        ${CMAKE_CURRENT_SOURCE_DIR}/worker_util.c
        ${CMAKE_CURRENT_SOURCE_DIR}/logger/logger.c
        ${CMAKE_CURRENT_SOURCE_DIR}/logger/logger_file.c
        ${CMAKE_CURRENT_SOURCE_DIR}/logger/logger_syslog.c
        ${CMAKE_CURRENT_SOURCE_DIR}/logger/logger_console.c
        ${CMAKE_CURRENT_SOURCE_DIR}/http/http_util.c
        ${CMAKE_CURRENT_SOURCE_DIR}/http/http_message.c
        ${CMAKE_CURRENT_SOURCE_DIR}/http/http_connection.c
        ${CMAKE_CURRENT_SOURCE_DIR}/http/http_router.c
        ${CMAKE_CURRENT_SOURCE_DIR}/http/http_context.c
        ${CMAKE_CURRENT_SOURCE_DIR}/maps/map.c
        ${CMAKE_CURRENT_SOURCE_DIR}/maps/map_helpers.c
        ${CMAKE_CURRENT_SOURCE_DIR}/html/html_entities.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/html/html_url.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/html/html.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/html/html_tests.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/hyperscan_tools.cxx
        ${CMAKE_CURRENT_SOURCE_DIR}/backtrace.cxx
        ${LIBCSSSRC})

# Librspamd-server
SET(RSPAMD_SERVER ${LIBRSPAMDSERVERSRC} PARENT_SCOPE)
SET(LIBSERVER_DEPENDS "${LIBCSS_DEPENDS}" PARENT_SCOPE)
SET(LIBSERVER_GENERATED "${LIBCSS_GENERATED}" PARENT_SCOPE)

=== src/libutil/CMakeLists.txt ===
# Librspamd-util
SET(LIBRSPAMDUTILSRC
				${CMAKE_CURRENT_SOURCE_DIR}/addr.c
				${CMAKE_CURRENT_SOURCE_DIR}/libev_helper.c
				${CMAKE_CURRENT_SOURCE_DIR}/expression.c
				${CMAKE_CURRENT_SOURCE_DIR}/fstring.c
				${CMAKE_CURRENT_SOURCE_DIR}/hash.c
				${CMAKE_CURRENT_SOURCE_DIR}/mem_pool.c
				${CMAKE_CURRENT_SOURCE_DIR}/printf.c
				${CMAKE_CURRENT_SOURCE_DIR}/radix.c
				${CMAKE_CURRENT_SOURCE_DIR}/regexp.c
				${CMAKE_CURRENT_SOURCE_DIR}/rrd.c
				${CMAKE_CURRENT_SOURCE_DIR}/shingles.c
				${CMAKE_CURRENT_SOURCE_DIR}/sqlite_utils.c
				${CMAKE_CURRENT_SOURCE_DIR}/str_util.c
				${CMAKE_CURRENT_SOURCE_DIR}/upstream.c
				${CMAKE_CURRENT_SOURCE_DIR}/util.c
				${CMAKE_CURRENT_SOURCE_DIR}/heap.c
				${CMAKE_CURRENT_SOURCE_DIR}/multipattern.c
				${CMAKE_CURRENT_SOURCE_DIR}/cxx/utf8_util.cxx
		${CMAKE_CURRENT_SOURCE_DIR}/cxx/util_tests.cxx
		${CMAKE_CURRENT_SOURCE_DIR}/cxx/file_util.cxx)
# Rspamdutil
SET(RSPAMD_UTIL ${LIBRSPAMDUTILSRC} PARENT_SCOPE)

=== src/rspamadm/CMakeLists.txt ===
--- 
+++ 
@@ -27,4 +27,5 @@
 ENDIF (NOT DEBIAN_BUILD)
 
 SET_TARGET_PROPERTIES(rspamadm PROPERTIES LINKER_LANGUAGE CXX)
+ADD_BACKWARD(rspamadm)
 INSTALL(TARGETS rspamadm RUNTIME DESTINATION bin)

=== debian/changelog ===
rspamd (3.8.1-1.2ubuntu2) plucky; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 05 Jan 2025 20:29:41 +0100

rspamd (3.8.1-1.2ubuntu1) plucky; urgency=medium

  * Merge with Debian; remaining changes:
    - d/rules: remove -Wl,-Bsymbolic-functions from linker flags if
      building on ubuntu and for armhf

 -- Matthias Klose <doko@ubuntu.com>  Mon, 28 Oct 2024 08:54:23 +0100

rspamd (3.8.1-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "autopkgtest regression with Perl 5.40: FAIL stderr: Duplicate
    specification": add patches from Niko Tiny to fix Getopt::Long usage with
    Perl 5.40. (Closes: #1078150)

 -- gregor herrmann <gregoa@debian.org>  Mon, 16 Sep 2024 23:23:06 +0200

rspamd (3.8.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Install systemd unit into /usr (DEP17 M2) (Closes: #1071914)

 -- Chris Hofstaedtler <zeha@debian.org>  Tue, 11 Jun 2024 00:57:11 +0200

rspamd (3.8.1-1ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:56:03 +1100

rspamd (3.8.1-1ubuntu2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:11:51 +0000

rspamd (3.8.1-1ubuntu1) noble; urgency=medium

  * Merge with Debian; remaining changes:
    - d/rules: remove -Wl,-Bsymbolic-functions from linker flags if
      building on ubuntu and for armhf

 -- Matthias Klose <doko@ubuntu.com>  Thu, 29 Feb 2024 13:19:43 +0100

rspamd (3.8.1-1) unstable; urgency=medium

  * New upstream version 3.8.1
  * d/patches: refresh patches
  * d/lintian: update version number
  * d/copyright: Update years and my email
  * d/sources: Update github.com/julianpoemp/codejar-linenumbers

 -- Sebastien Badia <sbadia@debian.org>  Sat, 27 Jan 2024 22:50:06 +0100

=== debian/control ===
Source: rspamd
Section: mail
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Sebastien Badia <sbadia@debian.org>
Uploaders: Mikhail Gusarov <dottedmag@debian.org>,
           Jerome Lebleu <jerome@maroufle.fr>,
           Sergio Durigan Junior <sergiodj@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libglib2.0-dev,
               libhyperscan-dev [amd64 i386],
               libicu-dev,
               libjemalloc-dev,
               libluajit-5.1-dev [amd64 arm64 armel armhf i386 mips mips64el mipsel ppc64] | liblua5.1-dev,
               libpcre2-dev,
               libsodium-dev,
               libsqlite3-dev,
               libssl-dev,
               libunwind-dev [amd64 arm64 armel armhf hppa i386 mips64el mipsel powerpcspe ppc64 ppc64el sh4],
               ragel,
               zlib1g-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://rspamd.com
Vcs-Git: https://salsa.debian.org/debian/rspamd.git
Vcs-Browser: https://salsa.debian.org/debian/rspamd

Package: rspamd
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser,
         ca-certificates,
         fonts-glyphicons-halflings,
         libjs-bootstrap4,
         libjs-jquery,
         libjs-requirejs,
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Recommends: redis-server
Description: Rapid spam filtering system
 Rspamd is a rapid, modular and lightweight spam filter. It is designed to work
 with big amount of mail and can be easily extended with own filters written in
 Lua.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
# please blhc
export ASMFLAGS = $(CPPFLAGS)

include /usr/share/dpkg/architecture.mk

ifneq ($(filter amd64 arm64 armel armhf i386 mips mips64el mipsel ppc64, $(DEB_HOST_ARCH)),)
  LUAJIT = ON
else
  LUAJIT = OFF
endif

ifneq ($(filter amd64 i386, $(DEB_HOST_ARCH)),)
  HYPERSCAN=ON
else
  HYPERSCAN=OFF
endif

ifneq ($(filter amd64 arm64 armel armhf hppa i386 mips64el mipsel powerpcspe ppc64 ppc64el sh4, $(DEB_HOST_ARCH)),)
  UNWIND=ON
else
  UNWIND=OFF
endif

# LP: #2027879
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
ifeq (armhf, $(DEB_TARGET_ARCH))
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions
endif
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCONFDIR=/etc/rspamd \
		-DMANDIR=/usr/share/man \
		-DRUNDIR=/run/rspamd \
		-DDBDIR=/var/lib/rspamd \
		-DLOGDIR=/var/log/rspamd \
		-DSHAREDIR=/usr/share/rspamd \
		-DLIBDIR=/usr/lib/rspamd \
		-DINCLUDEDIR=/usr/include \
		-DSYSTEMDDIR=/usr/lib/systemd/system \
		-DNO_SHARED=ON \
		-DDEBIAN_BUILD=1 \
		-DENABLE_JEMALLOC=ON \
		-DENABLE_OPTIMIZATION=OFF \
		-DENABLE_FULL_DEBUG=OFF \
		-DENABLE_PCRE2=ON \
		-DENABLE_LUAJIT=$(LUAJIT) \
		-DENABLE_LIBUNWIND=$(UNWIND) \
		-DENABLE_HYPERSCAN=$(HYPERSCAN) \
		-DWANT_SYSTEMD_UNITS=ON \
		-DENABLE_STATIC_LIBCXX=OFF \
		-DENABLE_LIBCXX=OFF \
		-DCMAKE_BUILD_WITH_INSTALL_RPATH=ON

override_dh_makeshlibs:
	dh_makeshlibs -Xlibrspamd-actrie -Xlibrspamd-ev -Xlibrspamd-kann -Xlibrspamd-replxx -Xlibrspamd-server

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/modules.c

override_dh_fixperms:
	dh_fixperms
	chmod 750 $(CURDIR)/debian/rspamd/var/lib/rspamd
	chmod 750 $(CURDIR)/debian/rspamd/var/log/rspamd

## rspamd 3.8.4

=== debian/changelog ===
rspamd (3.8.4-1~93fa4f6dc~noble) UNRELEASED; urgency=medium

  * Automated build

 -- Vsevolod Stakhov <vsevolod@rspamd.com>  Mon, 26 Feb 2024 09:41:06 +0000

rspamd (2.5) unstable; urgency=low

  * New release.

 -- Vsevolod Stakhov <vsevolod@rspamd.com>  Fri, 16 Feb 2020 23:10:27 +0000
